#include <string>
#include <admin>
#include <adminlib>

#define ACCESS_CONSOLE 131072

new g_maxplayers;
new g_WatchingPlayer[MAX_PLAYERS];

public plugin_init() {
	plugin_registerinfo("Admin Watch","Watching automatically player when in spectator mode","1.0");
	plugin_registercmd("admin_watch","admin_watch",ACCESS_ALL,"admin_watch [Player]: switches always to player you want to watch being spectator");
	plugin_registercmd("admin_unwatch","admin_unwatch",ACCESS_ALL,"admin_unwatch: stops switching to player");
	g_maxplayers = maxplayercount();
	return PLUGIN_CONTINUE;
}

public plugin_disconnect(HLUserName,UserIndex) {
	new Text[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new i;
	for (i=1;i<=g_maxplayers;i++){
		//target left server
		if(g_WatchingPlayer[i]==UserIndex){
			if(playerinfo(i,User,MAX_NAME_LENGTH)){
				snprintf(Text,MAX_TEXT_LENGTH,"[ADMIN-WATCH]^nTarget has left the server.^nStop watching.");
				messageex(User,Text,print_tty);
				g_WatchingPlayer[i]=0;
			}
		}
	}
	
	//spectating admin left server
	if(g_WatchingPlayer[UserIndex]>0){
		g_WatchingPlayer[UserIndex]=0;
	}
	return PLUGIN_CONTINUE;
}

public admin_watch(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Target[MAX_NAME_LENGTH];
	new iTarget;

	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	
	get_username(Data,Target,MAX_NAME_LENGTH);
	if(check_user(Target)) {
		get_userindex(Target,iTarget);
		g_WatchingPlayer[UserIndex]=iTarget;
		snprintf(Data, MAX_TEXT_LENGTH, "[ADMIN-WATCH] Start watching: %s. You must be dead or spectator!", Target);
		selfmessage(Data);
		execclient(User,"spec_mode 4");
		set_timer("check_player",1,99999);
	}else{
		snprintf(Data, MAX_TEXT_LENGTH, "[ADMIN-WATCH] Sorry, can't find player '%s'. Please try again!", Target);
		selfmessage(Data);
	}
	return PLUGIN_HANDLED;
}

public admin_unwatch(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new watchTarget[MAX_NAME_LENGTH];
	
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	
	if (g_WatchingPlayer[UserIndex]>0){
		if(playerinfo(g_WatchingPlayer[UserIndex],watchTarget,MAX_NAME_LENGTH)){
			snprintf(Data, MAX_TEXT_LENGTH, "[ADMIN-WATCH] You stop now watching: %s", watchTarget);
			selfmessage(Data);
			g_WatchingPlayer[UserIndex]=0;
		}
	}else{
		snprintf(Data, MAX_TEXT_LENGTH, "[ADMIN-WATCH] You currently not watching any player. Try admin_watch playername first!");
		selfmessage(Data);
	}
	return PLUGIN_HANDLED;
}
	
	
public check_player(Timer,Repeat,HLName,HLParam) {
	new Text[MAX_TEXT_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Target[MAX_NAME_LENGTH];
	new watchTarget[MAX_NAME_LENGTH];
	new iDead;
	new iDeadTarget;
	new i;
	
	for (i=1;i<=g_maxplayers;i++){
		if(g_WatchingPlayer[i]>0){
			if(playerinfo(i,User,MAX_NAME_LENGTH,_,_,_,iDead)){
				if(iDead){
					if(playerinfo(g_WatchingPlayer[i],watchTarget,MAX_NAME_LENGTH,_,_,_,iDeadTarget)){
						if(!iDeadTarget){
							snprintf(Text,MAX_TEXT_LENGTH,"[ADMIN-WATCH]^nSearching Target: %s",watchTarget);
							messageex(User,Text,print_tty);
							
							gettarget(User,Target,MAX_NAME_LENGTH);
							
							//snprintf(Text,MAX_TEXT_LENGTH,"[DEBUG] Looking at: %s",Target);
							//say(Text);
							
							if(strlen(Target)>0){
								if(strcmp(Target,watchTarget)!=0){
									snprintf(Text,MAX_TEXT_LENGTH,"[ADMIN-WATCH]^nCurrently watching: %s ^nWrong Target -> switch to next",Target);
									messageex(User,Text,print_tty);
									execclient(User,"+attack; wait; -attack");
								}else{
									snprintf(Text,MAX_TEXT_LENGTH,"[ADMIN-WATCH]^nWatching Target:^n%s",watchTarget);
									messageex(User,Text,print_tty);
								}
							}
						}else{
							snprintf(Text,MAX_TEXT_LENGTH,"[ADMIN-WATCH]^n%s is dead!^nWaiting for next round!",watchTarget);
							messageex(User,Text,print_tty);
						}
					}
				}
			}			
		}
	}
}
